<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>HowTo make a deposit?</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 2.2  (Linux)">
	<META NAME="CREATED" CONTENT="20080122;13345000">
	<META NAME="CHANGEDBY" CONTENT="Vincent Mahe">
	<META NAME="CHANGED" CONTENT="20080122;13345000">
</HEAD>
<BODY LANG="fr-FR" BGCOLOR="#ffffff" DIR="LTR">
<H1><IMG SRC="../img/Subclipse8.png" NAME="graphics5" ALIGN=LEFT WIDTH=408 HEIGHT=74 BORDER=0><BR CLEAR=LEFT><FONT FACE="Nimbus Sans L"><FONT SIZE=5>HowTo
make a deposit?</FONT></FONT></H1>
<P>A contribution must be done as a new directory in an existing
samples project (like org.openembedd.uml2.sample) or a new project
(only if any project exists corresponding to the sample main
metamodel). See the <I><B>Tree &amp; names policy</B></I> in the <I><B>What
is the models repository?</B></I> Chapter.</P>
<P>We illustrate the process with an example based on an UML2 simple
model designed with OpenEmbeDD Topcased UML2 modeler. The sample
itself is two files:</P>
<UL>
	<LI><P>inheritance1.uml (the UML2 model in a XMI format)</P>
	<LI><P>inheritance1.umldi (graphical part of the model).</P>
</UL>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>First step: a
&laquo;&nbsp;metamodel&nbsp;&raquo; project</I></FONT></FONT></H2>
<P>As our sample is an UML2 model, we need to embedd it in an UML2
samples project.</P>
<P>With respect to the repository naming policy, we created a new
project in Eclipse, named <FONT FACE="Courier 10 Pitch"><FONT SIZE=2>org.openembedd.uml2.sample</FONT></FONT>.</P>
<P>You must use an existing sample project if it corresponds to the
metamodel used in the sample.</P>
<P>Rem : we (the repository maintainers) will probably split large
projects concerning wide metamodels like UML2 into subprojects when
the number of samples increases.</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Second step: a sample
directory</I></FONT></FONT></H2>
<P>As each sample (model or set of models) must be put in its own
directory at the root of a metamodel project, just create a new
directory, with respect to naming policy.</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Third step: the
metadata</I></FONT></FONT></H2>
<P>You must create a .dublincore metadata file at the root of the
second step directory, because the automated web pages generator will
search metadata in the first level directories in the projects. You
can name the metadata file with respect to naming policy.</P>
<P>The DublinCore editor is embedded in the OpenEmbeDD Model Samples
Repository feature you can get from <A HREF="http://openembedd.org/experimental/update">OpenEmbeDD
experimental update site</A> (in DevTools part). In the sample
directory, right click and then choose <I>New</I> -&gt; <I>Other</I>
-&gt; <I>OpenEmbeDD</I> -&gt; <I>DublinCore Model Metadata</I>. The
editor builts up a new metadata with all required items. You must
fulfill them and check the model validity (right click on <I>Metadata</I>
and <I>Validate</I>).</P>
<P>If your model sample is always stored on the web and you want not
duplicate it, you must add in your metadata file a <I><B>Relation</B></I>
(the value must be the URI of the sample) with the <I><B>ExternalStorage</B></I><B>
qualifier</B>. You do not need the fourth step.</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Fourth step: the
sample</I></FONT></FONT></H2>
<P>You can now store your model(s) and their full documentation (with
some code samples if you like) into the sample directory.</P>
<P>You are free to put your model(s) inside it or in subdirectories,
depending the degree of complexity of the sample and the way you want
to be user-friendly.</P>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>Fifth step: commit the
project</I></FONT></FONT></H2>
<P>Once you have managed and verified your sample stuff, you must
commit the metamodel project to the OpenEmbeDD Model Samples
Repository, through SVN, in order to publish the sample.</P>
<P>A automated tool will extract informations from the .dublincore
file and generate the corresponding HTML page and will insert links
into search pages. This job is ran each nigth (around 0 GMT).</P>
</BODY>
</HTML>